#include <stdio.h>
#include <stdlib.h>

#define MAX_X      11 // HxTCY
#define MAX_Y       8 // HyTCY
#define MAX_EPI  1000 // Gs\[h
#define MAX_STEP  200 // Xebv
#define ACT_NUM     4 // sB㉺E4ʂ

// X^[gn_
int sx = 1;
int sy = 1;
// 0:ǁC1:iƂjC2:S[, 3:R
// H̊Og͕ǂň͂ނ
int s[MAX_Y][MAX_X] = {
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 1, 1, 1, 1, 1, 1, 1, 1, 2, 0 },
  { 0, 1, 1, 3, 3, 3, 3, 3, 1, 1, 0 },
  { 0, 1, 1, 3, 3, 3, 3, 3, 1, 1, 0 },
  { 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0 },
  { 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0 },
  { 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
};

// TDwKpp[^
double alpha = 0.2;   // wK
double gamma = 0.9;   // 
double epsilon = 0.3; //-greedẙm
double Q[MAX_Y][MAX_X][ACT_NUM]; // sl

// ȉ̊֐͏ȗ
double random(); // 0ȏ1̗𐶐֐

//SARSAwK֐
//Ԃ̕\(x,y)WƂȂĂ邱Ƃɒ
void sarsa(int x, int y, int a, double r, int nx, int ny, int na){
  Q[y][x][a] = Q[y][x][a] 
                  + alpha * (r + gamma * Q[ny][nx][na] - Q[y][x][a]);
}

// sl̏
void init() {
  int i, j, k;
  for (i = 0; i < MAX_Y; i++) {
    for (j = 0; j < MAX_X; j++) {
      for (k = 0; k < ACT_NUM; k++) {
        Q[i][j][k] = random() - 0.5; // [-0.5, 0.5)̗ŏ
      }
    }
  }
}

// so͂֐C0`ACT_NUM-1ԂB
int action(int x, int y) {
  int k;
  int act;
  if (random() < epsilon) {
    return (int)(random() * ACT_NUM);
  } else {
    double max = Q[y][x][0];
    act = 0;
    for (k = 1; k < ACT_NUM; k++) {
      if (max < Q[y][x][k]) {
        max = Q[y][x][k];
        act = k;
      }
    }
    return act;
  }
}

// œKsŕ\֐
void showArrow() {
  int i, j, k;
  for (i = 1; i < MAX_Y - 1; i++) {
    for (j = 1; j < MAX_X - 1; j++) {
      switch (s[i][j]) {
      case 1: // ̏ꍇ
      {
        int argmaxQ = 0;
        double maxQ = Q[i][j][0];
        for (k = 1; k < ACT_NUM; k++) {
          if (maxQ < Q[i][j][k]) {
            argmaxQ = k;
            maxQ = Q[i][j][k];
          }
        }
        switch (argmaxQ) {
        case 0:
          printf("");
          break;
        case 1:
          printf("");
          break;
          case 2:
          printf("");
          break;
        default:
          printf("");
          break;
        }
        break;
      }
      case 2: // S[̏ꍇ
        printf("f");
        break;
      case 3: // Ȑꍇ
        printf("~");
        break;
      default:
        break;
      }
    }
    printf("\n");
  }
}

void main() {
  int epi, step;
  int x, y, a, nx, ny, na;

  init(); // 

  for (epi = 0; epi < MAX_EPI; epi++) {
    x = sx;  // ݂̏ԂxW
    y = sy;  // ݂̏ԂyW
    a;       // ݂̏Ԃɂs
    nx = sx; // ԂxW
    ny = sy; // ԂyW
    na = 0;  // Ԃɂs

    a = action(x, y); // ݂̏Ԃɂsa
    for (step = 0; step < MAX_STEP; step++) {
      // asCVrƎs'ϑ
      switch (a) {
      case 0: // 
        if (s[y - 1][x] != 0) ny--;
        break;
      case 1: // 
        if (s[y + 1][x] != 0) ny++;
        break;
      case 2: // 
        if (s[y][x - 1] != 0) nx--;
        break;
      case 3: // E
        if (s[y][x + 1] != 0) nx++;
        break;
      }

      na = action(nx, ny); // Ԃɂsa

      // slQ(s,a)XV
      if (s[y][x] == 2) {        // S[Ƃ
        sarsa(x, y, a, 1, nx, ny, na);
        break; // step̃[v𔲂
      } else if (s[y][x] == 3) { // RɗƂ
        sarsa(x, y, a, -100, nx, ny, na);
        break; // step̃[v𔲂
      } else {                   // ʂɈړƂ
        sarsa(x, y, a, -1, nx, ny, na);
      }
      x = nx;
      y = ny;
      a = na;
    }
  }
  showArrow();
}

// 0ȏ1̈l𔭐֐
double random() {
  return (double)(rand() / (RAND_MAX + 1.0));
}