#include<iostream>
#include<vector>
#include<queue>
#include<map>
#include<algorithm>
using namespace std;

//O[oϐ錾
const int MAX_V = 1000;		//ő咸_
vector<int> graph[MAX_V];	//Ot̗אڃXg
int parent[MAX_V];			//oHɂem[h̐e
int g[MAX_V];				//g(n)
int h[MAX_V];				//h(n)
int f[MAX_V];				//f(n)

typedef pair<int, int> Link;	//Ň^Link̒`
map<Link, int> cost;			//ÑRXgɊւAzz

//LinkԂ
Link link(int a, int b){ return make_pair(a, b); }

//}2.13̃Ot𐶐
void gen_graph(){
	//em[h̎qm[hݒ
	graph[1] = vector<int>{ 2, 3, 4 };
	graph[2] = vector<int>{ 5, 6 };
	graph[3] = vector<int>{ 2, 4 };
	graph[4] = vector<int>{ 7 };
	graph[5] = vector<int>{ 6 };
	graph[6] = vector<int>{ 3, 4 };

	//eÑRXgݒ
	cost[link(1, 2)] = 2;	cost[link(1, 3)] = 1;	cost[link(1, 4)] = 9;
	cost[link(2, 5)] = 1;	cost[link(2, 6)] = 2;
	cost[link(3, 2)] = 2;	cost[link(3, 4)] = 5;
	cost[link(4, 7)] = 4;
	cost[link(5, 6)] = 3;
	cost[link(6, 3)] = 1;	cost[link(6, 4)] = 1;

	//em[hh(n)̐lݒ
	h[1] = 5;	h[2] = 2;	h[3] = 1;	h[4] = 3;
	h[5] = 7;	h[6] = 4;	h[7] = 0;

}

//oL[qɗvfn܂܂trueԂ
bool include(deque<int>& q, int n){
	return q.end() != find(q.begin(), q.end(), n);
}

//Link(a,b)̃RXgԂ
int c(int a, int b){
	Link l(a, b);
	if (cost.find(l) != cost.end())	return cost[l];

	return INT_MAX;	//+Ԃ
}

//A*T
void a_star_search(int start, int goal){
	deque<int> open({ start }), closed;
	g[start] = 0;

	while (!open.empty()){	// openłȂ
		// open̐擪vfo
		int n = open.front(); open.pop_front();
		if (n == goal)	return;

		// nclosedɒǉ
		closed.push_back(n);

		// n̎qm[h̃Xgtɂ
		std::vector<int> L = graph[n];
		reverse(L.begin(), L.end());

		for (int m : L){	// n̊eqm[hmɂ
			// mopenɂclosedɂ܂܂ȂƂ
			if (!include(open, m) && !include(closed, m)){
				g[m] = g[n] + c(n, m);
				f[m] = g[m] + h[m];
				parent[m] = n;
				//mopen̐擪ɒǉ
				open.push_front(m);
			}
			// mopenɊ܂܂Ƃ
			else if (include(open, m)){
				if (g[n] + c(n, m) + h[m] < f[m]){
					g[m] = g[n] + c(n, m);
					f[m] = g[m] + h[m];
					parent[m] = n;
				}
			}
			// mclosedɊ܂܂Ƃ
			else if (include(closed, m)){
				if (g[n] + c(n, m) + h[m] < f[m]){
					g[m] = g[n] + c(n, m);
					f[m] = g[m] + h[m];
					parent[m] = n;
					// mopen̐擪ɒǉ
					open.push_front(m);
					// mclosed폜
					closed.erase(find(closed.begin(), closed.end(), m));
				}
			}
		}
		// f(n)open\[g
		sort(open.begin(), open.end(), [](int a, int b){ return f[a] < f[b]; });
	}
}

void main(){
	gen_graph();
	int start = 1, goal = 7;

	a_star_search(start, goal);

	// startgoal܂ł̌oHtň
	int n = goal;
	cout << n;
	while (n != start){
		n = parent[n];
		cout << " <- " << n;
	}
	cout << endl;
}



