#include<iostream>
#include<vector>
#include<queue>
#include<map>
#include<algorithm>
using namespace std;

//O[oϐ錾
const int MAX_V = 1000;		//ő咸_
vector<int> graph[MAX_V];	//Ot̗אڃXg
int parent[MAX_V];			//oHɂem[h̐e
int g[MAX_V];				//g(n)
int h[MAX_V];				//h(n)

typedef pair<int, int> Link;	//Ň^Link̒`
map<Link, int> cost;			//ÑRXgɊւAzz

//LinkԂ
Link link(int a, int b){ return make_pair(a, b); }

//}2.12̃Ot𐶐
void gen_graph(){
	//em[h̎qm[hݒ
	graph[1] = vector<int>{ 2, 3, 4 };
	graph[2] = vector<int>{ 5, 6 };
	graph[3] = vector<int>{ 2, 4, 7 };
	graph[4] = vector<int>{ 7 };
	graph[5] = vector<int>{ 6 };
	graph[6] = vector<int>{ 3, 7 };

	//eÑRXgݒ
	cost[link(1, 2)] = 3;	cost[link(1, 3)] = 2;	cost[link(1, 4)] = 4;
	cost[link(2, 5)] = 2;	cost[link(2, 6)] = 1;
	cost[link(3, 2)] = 1;	cost[link(3, 4)] = 2;	cost[link(3, 7)] = 5;
	cost[link(4, 7)] = 3;
	cost[link(5, 6)] = 3;
	cost[link(6, 3)] = 1;	cost[link(6, 7)] = 2;

	//em[hh(n)̐lݒ
	h[1] = 4;	h[2] = 3;	h[3] = 2;	h[4] = 1;
	h[5] = 2;	h[6] = 1;	h[7] = 0;

}

//oL[qɗvfn܂܂trueԂ
bool include(deque<int>& q, int n){
	return q.end() != find(q.begin(), q.end(), n);
}

//Link(a,b)̃RXgԂ
int c(int a, int b){
	Link l(a, b);
	if (cost.find(l) != cost.end())	return cost[l];

	return INT_MAX;	//+Ԃ
}

//Ro@
bool hill_climbing(int start, int goal){
	deque<int> open({ start }), closed;

	while (!open.empty()){	// openłȂ
		// open̐擪vfo
		int n = open.front(); open.pop_front();
		if (n == goal)	return true;

		// nclosedɒǉ
		closed.push_back(n);

		// n̎qm[hȂƂ
		if (graph[n].empty()) return false;

		// n̎qm[hn'̒h(n')ŏłn'mƂ
		int m = *min_element(graph[n].begin(), graph[n].end(), [](int a, int b){ return h[a] < h[b]; });

		parent[m] = n;
		// mopen̐擪ɒǉ
		open.push_front(m);
	}
}

void main(){
	gen_graph();
	int start = 1, goal = 7;

	if (!hill_climbing(start, goal))
		return;

	// startgoal܂ł̌oHtň
	int n = goal;
	cout << n;
	while (n != start){
		n = parent[n];
		cout << " <- " << n;
	}
	cout << endl;
}
