#include<iostream>
#include<vector>
#include<queue>
#include<map>
#include<algorithm>
using namespace std;

//O[oϐ錾
const int MAX_V = 1000;		//ő咸_
vector<int> graph[MAX_V];	//Ot̗אڃXg
int h[MAX_V];				//h(n)

typedef pair<int, int> Link;	//Ň^Link̒`
map<Link, int> cost;			//ÑRXgɊւAzz

//LinkԂ
Link link(int a, int b){ return make_pair(a, b); }

//}2.13̃Ot𐶐
void gen_graph(){
	//em[h̎qm[hݒ
	graph[1] = vector<int>{ 2, 3, 4 };
	graph[2] = vector<int>{ 5, 6 };
	graph[3] = vector<int>{ 2, 4 };
	graph[4] = vector<int>{ 7 };
	graph[5] = vector<int>{ 6 };
	graph[6] = vector<int>{ 3, 4 };

	//eÑRXgݒ
	cost[link(1, 2)] = 2;	cost[link(1, 3)] = 1;	cost[link(1, 4)] = 9;
	cost[link(2, 5)] = 1;	cost[link(2, 6)] = 2;
	cost[link(3, 2)] = 2;	cost[link(3, 4)] = 5;
	cost[link(4, 7)] = 4;
	cost[link(5, 6)] = 3;
	cost[link(6, 3)] = 1;	cost[link(6, 4)] = 1;

	//em[hh(n)̐lݒ
	h[1] = 5;	h[2] = 2;	h[3] = 1;	h[4] = 3;
	h[5] = 7;	h[6] = 4;	h[7] = 0;

}

//Link(a,b)̃RXgԂ
int c(int a, int b){
	Link l(a, b);
	if (cost.find(l) != cost.end())	return cost[l];

	return INT_MAX;	//+Ԃ
}

// f(n)f_bound𒴂Ȃ͈͂łA*ASY
int a_star_search(int n, int goal, int g, vector<int>& path, int f_bound){
	int f = g + h[n];
	if (f > f_bound) return f;
	if (n == goal) return f_bound;

	int s = INT_MAX;	// s=+
	for (int m : graph[n]){	// n̊eqm[hmɂ
		vector<int> p({ m });

		// mgoal܂f_bound𒴂Ȃ͈͂A*T
		f = a_star_search(m, goal, g + c(n, m), p, f_bound);

		// f_bound𒴂Ȃ͈͂ŌoHƂ
		if (f == f_bound){
			path.insert(path.end(), p.begin(), p.end());
			return f_bound;
		}
		// f_bound𒴂Ă܂Ƃ́C߂lf̍ŏlsƂ
		s = min(f, s);
	}
	return s;
}

//[A*ASY
void iterative_deepening_a_star_search(int start, int goal){
	vector<int> path;
	int f_bound, f = h[start];

	// startf_boundȓgoalɎȂꍇf_bound𑝂₵ČJԂ
	do {
		f_bound = f;
		f = a_star_search(start, goal, 0, path, f_bound);
	} while (f != f_bound);

	// startgoal܂ł̌oH
	cout << start;
	for (int a : path){ cout << "->" << a; }
	cout << endl;
}

void main(){
	gen_graph();
	int start = 1, goal = 7;

	iterative_deepening_a_star_search(start, goal);
}



