#include<iostream>
#include<vector>
#include<queue>
#include<map>
#include<algorithm>
using namespace std;

// State^`
typedef pair<int, int> State;

//O[oϐ錾
map<State, State> parent;  

//StateԂ
State state(int a, int b){ return make_pair(a, b); }

//oL[qɗvfn܂܂trueԂ
bool include(deque<State>& q, State n){
  return q.end() != find(q.begin(), q.end(), n);
}

//n̎qm[hԂ
vector<State> successors(State n){
  int a = n.first, b = n.second;
  vector<State> suc;
  //4bge𖞔tɂ
  if (a < 4){ suc.push_back(state(4, b)); }
  //3bge𖞔tɂ
  if (b < 3){ suc.push_back(state(a, 3)); }
  //4bge̐̂Ă
  if (a > 0){ suc.push_back(state(0, b)); }
  //3bge̐̂Ă
  if (b > 0){ suc.push_back(state(a, 0)); }
  if (a < 4 && b!=0){
    //4bge킪tɂȂ悤ڂ
    if (b > 4 - a){ suc.push_back(state(4, b - (4 - a))); }
    //3bgeׂ̐Ĉڂ
    else { suc.push_back(state(a + b, 0)); }
  }
  if (b < 3 && a!=0){
    //3bge킪tɂȂ悤ڂ
    if (a > 3 - b){ suc.push_back(state(a - (3 - b), 3)); }
    //4bgeׂ̐Ĉڂ
    else { suc.push_back(state(0, b + a)); }
  }
  return suc;
}

//DT
State breadth_first_search(State start){
  deque<State> open({ start }), closed;  

  while (!open.empty()){  // openłȂ
    // open̐擪vfo
    State n = open.front(); open.pop_front();  

    //ڕWԂǂ̔
    if (n.first == 2 || n.second == 2) return n;

    // nclosedɒǉ
    closed.push_back(n);  

    for (State m : successors(n)){  // n̊eqm[hmɂ
      // mopenɂclosedɂ܂܂ȂƂ 
      if (!include(open, m) && !include(closed, m)){
        parent[m] = n;
        // childopen̍Ōɒǉ
        open.push_back(m);  
      }
    }
  }
}

void main(){
  State start = state(0,0);
  State goal = breadth_first_search(start);

  // startgoal܂ł̌oHtň
  State n = goal;
  cout << "(" << n.first << "," << n.second << ")";
  while (n != start){
    n = parent[n];
    cout << " <- " << "(" << n.first << "," << n.second << ")";
  }
  cout << endl;
}
