#include <math.h>
#include <stdlib.h>
#include <stdio.h>

#define IN_NUM   2   // ͑w̃jbg
#define HID_NUM  3   // Bw̃jbg
#define OUT_NUM  1   // o͑w̃jbg
#define PAT_NUM  4   // wKf[^̐
#define ETA      0.2 // wK

// 1w̌d݁i+1̓oCAXjbgj
double w1[IN_NUM + 1][HID_NUM]; 
// 2w̌d݁i+1̓oCAXjbgj
double w2[HID_NUM + 1][OUT_NUM];
// Bw̏óiwKŎgpj
double yy1[HID_NUM];

// ͐M
double input[PAT_NUM][IN_NUM]  = { {0,0},{0,1},{1,0},{1,1} };
// tM
double teach[PAT_NUM][OUT_NUM] = { {0},  {1},  {1},  {0} };

// ȉ̎l̊֐͏ȗ
double random(); // 0ȏ1̈l𔭐֐
double sigmoid(double x);             // VOCh֐
void output(double* in, double* out); // o͊֐
double learn(double* in, double* te); // 덷t`d@̊֐

// dݏ֐B-0.5`0.5̗ŏ
void init() {
  int i, j;
  // 1w̌d݂̏
  for (i = 0; i < IN_NUM + 1; i++) {
    for (j = 0; j < HID_NUM; j++) {
      w1[i][j] = random() - 0.5;
    }
  }
  // 2w̌d݂̏
  for (i = 0; i < HID_NUM + 1; i++) {
    for (j = 0; j < OUT_NUM; j++) {
      w2[i][j] = random() - 0.5;
    }
  }
}

void main() {
  int i;
  init();

  for (i = 0; i < 30000; i++) {      // 10000wK
    int n = (int)(PAT_NUM * random()); // _ɊwKf[^I
    double e = learn(input[n], teach[n]);
    printf("%derror=%f\n", i, e);
  }
  
  // ̓f[^^Ƃ̏o͂mF
  for (i = 0; i < PAT_NUM; i++) {
    double out[OUT_NUM];  // o͂i[z
    output(input[i], out);
    printf("(%f,%f)->%f\n", input[i][0], input[i][1], out[0]);
  }
}

// 0ȏ1̈l𔭐֐
double random() {
  return (double)(rand() / (RAND_MAX + 1.0));
}

//p.104
//VOCh֐
double sigmoid(double x) {
  return 1.0 / (1.0 + exp(-x));
}

//p.104
//in ͓͐M
//out ͏óiĂяoɏo͂zŕԋpj
void output(double* in, double* out) {
  int i, j;
  //Bw̌vZ
  for (j = 0; j < HID_NUM; j++) {
    yy1[j] = 0;
    //ʏ̃jbg
    for (i = 0; i < IN_NUM; i++) {
      yy1[j] += w1[i][j] * in[i];
    }
    //oCAXjbg
    yy1[j] += w1[i][j];
    yy1[j] = sigmoid(yy1[j]);
  }
  //o͑w̌vZ
  for (j = 0; j < OUT_NUM; j++) {
    out[j] = 0;
    //ʏ̃jbg
    for (i = 0; i < HID_NUM; i++) {
      out[j] += w2[i][j] * yy1[i];
    }
    //oCAXjbg
    out[j] += w2[i][j];
    out[j] = sigmoid(out[j]);
  }
}

//p.108
// in ͓̓f[^Cte ͋tM
// ߂l͊wK덷error
double learn(double* in, double* te) {
  int i, j, n;
  double out[OUT_NUM], delta[OUT_NUM];
  double error = 0;
  //output() ĂяoCBw̏oyy1[] Əo͑w̏oout[] vZ
  output(in, out);
  
  //덷̌vZ
  for (j = 0; j < OUT_NUM; j++) {
    error += (te[j] - out[j]) * (te[j] - out[j]);
  }
  
  //o͑ẘwK
  for (j = 0; j < OUT_NUM; j++) {
    delta[j] = out[j] * (1.0 - out[j]) * (te[j] - out[j]);
    //ʏ̃jbg
    for (i = 0; i < HID_NUM; i++) {
      w2[i][j] += ETA * delta[j] * yy1[i];
    }
    //oCAXjbg
    w2[i][j] += ETA * delta[j];
  }

  //BẘwK
  for (j = 0; j < HID_NUM; j++) {
    double del = 0;
    for (n = 0; n < OUT_NUM; n++) {
      del += delta[n] * w2[j][n];
    }
    //ʏ̃jbg
    for (i = 0; i < IN_NUM; i++) {
      w1[i][j] += ETA * yy1[j] * (1.0 - yy1[j]) * del * in[i];
    }
    //oCAXjbg
    w1[i][j] += ETA * yy1[j] * (1.0 - yy1[j]) * del;
  }
  return error;
}